blob: 135e4257b423ba9109502681ac8b75a5ff3314f5 [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000016
Ollie Lho184a4042005-11-26 21:55:36 +000017PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000018
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000019###############################################################################
20# Defaults for the toolchain.
21
22# If you want to cross-compile, just run e.g.
23# make CC=i586-pc-msdosdjgpp-gcc
24# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000025#
26# Note for anyone editing this Makefile: gnumake will happily ignore any
27# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000028STRIP ?= strip
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000029INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000030DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000031PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000032MANDIR ?= $(PREFIX)/share/man
Nico Huber9e2dc2f2018-12-23 22:00:47 +010033CFLAGS ?= -Os -Wall -Wextra -Wno-unused-parameter -Wshadow -Wmissing-prototypes -Wwrite-strings
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000034EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000035RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000036PKG_CONFIG ?= pkg-config
37BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000038
Stefan Taunerfd0d4132012-09-25 21:24:55 +000039# The following parameter changes the default programmer that will be used if there is no -p/--programmer
40# argument given when running flashrom. The predefined setting does not enable any default so that every
41# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
42# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
43# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
44# system attached to an external programmer while the default programmer is set to the internal programmer, and
45# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
46# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
Thomas Heijligen84e9c912021-06-01 16:22:14 +020047# values can be found when running 'flashrom --list-supported' under the 'Supported programmers' section.
48CONFIG_DEFAULT_PROGRAMMER_NAME ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000049# The following adds a default parameter for the default programmer set above (only).
Thomas Heijligen84e9c912021-06-01 16:22:14 +020050CONFIG_DEFAULT_PROGRAMMER_ARGS ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000051# Example: compiling with
Thomas Heijligen84e9c912021-06-01 16:22:14 +020052# make CONFIG_DEFAULT_PROGRAMMER_NAME=serprog CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
Stefan Tauner265fcac2014-06-02 00:12:23 +000053# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000054
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000055# If your compiler spits out excessive warnings, run make WARNERROR=no
56# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000057WARNERROR ?= yes
58
59ifeq ($(WARNERROR), yes)
60CFLAGS += -Werror
61endif
62
Stefan Taunere37735a2015-01-26 22:03:35 +000063ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000064PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000065override CPPFLAGS += -I$(LIBS_BASE)/include
66override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000067endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000068
Stefan Taunerbfb067b2016-01-07 18:13:07 +000069ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000070override PKG_CONFIG += --static
71override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000072endif
73
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000074# Set LC_ALL=C to minimize influences of the locale.
75# However, this won't work for the majority of relevant commands because they use the $(shell) function and
Martin Rothf6c1cb12022-03-15 10:55:25 -060076# GNU make does not relay variables exported within the makefile to their environment.
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000077LC_ALL=C
78export LC_ALL
79
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000080dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000081
82# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
83# in the build details file together with the original stdout output.
Pyry Kontio89cc73b2020-07-06 12:57:35 +090084debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(subst ','\'',$(1)) ; }' >&2; \
85 { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000086
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000087###############################################################################
Nico Huber7f898972021-06-27 13:30:50 +020088# Dependency handling.
89
90DEPENDS_ON_SERIAL := \
91 CONFIG_BUSPIRATE_SPI \
92 CONFIG_PONY_SPI \
93 CONFIG_SERPROG \
94
95DEPENDS_ON_BITBANG_SPI := \
Nico Huber29c68342021-06-27 14:34:16 +020096 CONFIG_DEVELOPERBOX_SPI \
Nico Huber7f898972021-06-27 13:30:50 +020097 CONFIG_INTERNAL \
98 CONFIG_NICINTEL_SPI \
99 CONFIG_OGP_SPI \
100 CONFIG_PONY_SPI \
101 CONFIG_RAYER_SPI \
102
103DEPENDS_ON_LIBPCI := \
104 CONFIG_ATAHPT \
105 CONFIG_ATAPROMISE \
106 CONFIG_ATAVIA \
107 CONFIG_DRKAISER \
108 CONFIG_GFXNVIDIA \
109 CONFIG_INTERNAL \
110 CONFIG_IT8212 \
111 CONFIG_NIC3COM \
112 CONFIG_NICINTEL \
113 CONFIG_NICINTEL_EEPROM \
114 CONFIG_NICINTEL_SPI \
115 CONFIG_NICNATSEMI \
116 CONFIG_NICREALTEK \
117 CONFIG_OGP_SPI \
118 CONFIG_SATAMV \
119 CONFIG_SATASII \
120
121DEPENDS_ON_LIBUSB1 := \
122 CONFIG_CH341A_SPI \
123 CONFIG_DEDIPROG \
124 CONFIG_DEVELOPERBOX_SPI \
125 CONFIG_DIGILENT_SPI \
126 CONFIG_PICKIT2_SPI \
127 CONFIG_RAIDEN_DEBUG_SPI \
128 CONFIG_STLINKV3_SPI \
Jean THOMASe28d8e42022-10-11 17:54:30 +0200129 CONFIG_DIRTYJTAG_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200130
131DEPENDS_ON_LIBFTDI := \
132 CONFIG_FT2232_SPI \
133 CONFIG_USBBLASTER_SPI \
134
135DEPENDS_ON_LIBJAYLINK := \
136 CONFIG_JLINK_SPI \
137
Nico Huberafca7ac2021-06-27 13:35:21 +0200138define mark_unsupported
139$(foreach p,$1, \
140 $(if $(filter $($(p)),yes), \
141 $(eval UNSUPPORTED_FEATURES += $(p)=yes), \
142 $(eval override $(p) := no)))
143endef
144
Nico Huber29c68342021-06-27 14:34:16 +0200145define filter_deps
146$(strip $(foreach p,$1, \
147 $(if $(filter $($(p)),yes), \
148 $(p))))
149endef
150
Nico Hubera54f5a42021-06-27 14:27:41 +0200151define disable_all
152$(foreach p,$1, \
153 $(eval override $(p) := no))
154endef
155
156ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
157$(call disable_all,$(DEPENDS_ON_LIBUSB1))
158endif
159
160ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
161$(call disable_all,$(DEPENDS_ON_LIBPCI))
162endif
163
Nico Huber7f898972021-06-27 13:30:50 +0200164###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +0000165# General OS-specific settings.
166# 1. Prepare for later by gathering information about host and target OS
167# 2. Set compiler flags and parameters according to OSes
168# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000169
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000170# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +0000171HOST_OS ?= $(shell uname)
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100172ifeq ($(findstring MINGW, $(HOST_OS)), MINGW)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000173# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
174CC = gcc
175endif
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100176
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000177ifneq ($(HOST_OS), SunOS)
Adam Kaufman064b1f22007-02-06 19:47:50 +0000178STRIP_ARGS = -s
179endif
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000180
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000181# Determine the destination OS.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000182# IMPORTANT: The following line must be placed before TARGET_OS is ever used
183# (of course), but should come after any lines setting CC because the line
184# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900185override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null \
186 | tail -1 | cut -f 2 -d'"'))
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000187
188ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000189override CPPFLAGS += -I/opt/local/include -I/usr/local/include
190override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000191endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000192
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000193ifeq ($(TARGET_OS), FreeBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000194override CPPFLAGS += -I/usr/local/include
195override LDFLAGS += -L/usr/local/lib
Andriy Gapon65c1b862008-05-22 13:22:45 +0000196endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000197
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000198ifeq ($(TARGET_OS), OpenBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000199override CPPFLAGS += -I/usr/local/include
200override LDFLAGS += -L/usr/local/lib
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000201endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000202
Stefan Taunerc65b8552013-09-12 15:48:39 +0000203ifeq ($(TARGET_OS), NetBSD)
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000204# Needs special `pciutils/pci.h` for older NetBSD packages
205PCIUTILS_PCI_H := $(shell [ -f /usr/pkg/include/pciutils/pci.h ] && echo -DPCIUTILS_PCI_H)
206override CPPFLAGS += -I/usr/pkg/include $(PCIUTILS_PCI_H)
Stefan Tauner45207062016-02-19 08:17:24 +0000207override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000208endif
209
210ifeq ($(TARGET_OS), DragonFlyBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000211override CPPFLAGS += -I/usr/local/include
212override LDFLAGS += -L/usr/local/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000213endif
214
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000215ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000216EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000217# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000218override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000219LIBS += -lgetopt
Nico Huberba681962021-06-27 13:39:23 +0200220# Missing serial support.
221$(call mark_unsupported,$(DEPENDS_ON_SERIAL))
222# Libraries not available for DOS
223$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000224endif
Ollie Lho184a4042005-11-26 21:55:36 +0000225
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000226# FIXME: Should we check for Cygwin/MSVC as well?
227ifeq ($(TARGET_OS), MinGW)
228EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000229# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000230FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000231# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000232# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000233FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100234
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000235# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
Nico Huberca621782021-06-27 13:53:49 +0200236$(call mark_unsupported,$(DEPENDS_ON_LIBPCI))
237# And programmers that need raw access.
238$(call mark_unsupported,CONFIG_RAYER_SPI)
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000239
Nico Huberca621782021-06-27 13:53:49 +0200240else # No MinGW
241
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100242# NI USB-845x only supported on Windows at the moment
Nico Huberca621782021-06-27 13:53:49 +0200243$(call mark_unsupported,CONFIG_NI845X_SPI)
244
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100245endif
246
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000247ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000248ifeq ($(MAKECMDGOALS),)
249.DEFAULT_GOAL := libflashrom.a
250$(info Setting default goal to libflashrom.a)
251endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000252FLASHROM_CFLAGS += -DSTANDALONE
Nico Huber71331032021-06-27 14:00:39 +0200253$(call mark_unsupported,CONFIG_DUMMY)
Stefan Taunere0168262016-02-21 11:18:24 +0000254# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
Nico Huber71331032021-06-27 14:00:39 +0200255$(call mark_unsupported,CONFIG_ATAPROMISE)
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000256# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Nico Huber71331032021-06-27 14:00:39 +0200257$(call mark_unsupported,CONFIG_BUSPIRATE_SPI CONFIG_SERPROG CONFIG_PONY_SPI)
Daniel Thompson45e91a22018-06-04 13:46:29 +0100258# Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Nico Huber71331032021-06-27 14:00:39 +0200259$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000260endif
261
Nico Huberdc8e54a2021-06-27 14:17:34 +0200262# Android is handled internally as separate OS, but it supports about the same drivers as Linux.
263ifeq ($(filter $(TARGET_OS),Linux Android), )
264$(call mark_unsupported,CONFIG_LINUX_MTD CONFIG_LINUX_SPI)
265$(call mark_unsupported,CONFIG_MSTARDDC_SPI)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000266endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000267
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000268ifeq ($(TARGET_OS), Android)
Nico Huberdc8e54a2021-06-27 14:17:34 +0200269# Android on x86 (currently) does not provide raw PCI port I/O operations.
270$(call mark_unsupported,CONFIG_RAYER_SPI)
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000271endif
272
Stefan Tauner037cd842013-08-25 00:10:56 +0000273###############################################################################
274# General architecture-specific settings.
275# Like above for the OS, below we verify user-supplied options depending on the target architecture.
276
Uwe Hermann44ffd582011-08-20 14:16:00 +0000277# Determine the destination processor architecture.
278# IMPORTANT: The following line must be placed before ARCH is ever used
279# (of course), but should come after any lines setting CC because the line
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000280# below uses CC itself.
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900281override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null \
282 | tail -1 | cut -f 2 -d'"'))
283override ENDIAN := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E endiantest.c 2>/dev/null \
284 | tail -1))
Uwe Hermann44ffd582011-08-20 14:16:00 +0000285
Nico Huberc8801732017-12-01 18:19:43 +0000286# Disable the internal programmer on unsupported architectures (everything but x86 and mipsel)
287ifneq ($(ARCH)-little, $(filter $(ARCH),x86 mips)-$(ENDIAN))
Nico Huber8945b812021-06-27 14:24:53 +0200288$(call mark_unsupported,CONFIG_INTERNAL)
Nico Huberc8801732017-12-01 18:19:43 +0000289endif
290
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000291# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000292# Right now this means the drivers below only work on x86.
293ifneq ($(ARCH), x86)
Nico Huber8945b812021-06-27 14:24:53 +0200294$(call mark_unsupported,CONFIG_NIC3COM CONFIG_NICREALTEK CONFIG_NICNATSEMI)
295$(call mark_unsupported,CONFIG_RAYER_SPI CONFIG_ATAHPT CONFIG_ATAPROMISE)
296$(call mark_unsupported,CONFIG_SATAMV)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000297endif
298
Nico Huber8945b812021-06-27 14:24:53 +0200299# Additionally disable all drivers needing raw access (memory, PCI, port I/O)
300# on architectures with unknown raw access properties.
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000301# Right now those architectures are alpha hppa m68k sh s390
Rosen Penev34d07f02019-07-02 00:14:01 -0700302ifneq ($(ARCH),$(filter $(ARCH),x86 mips ppc arm sparc arc))
Nico Huber8945b812021-06-27 14:24:53 +0200303$(call mark_unsupported,CONFIG_GFXNVIDIA CONFIG_SATASII CONFIG_ATAVIA)
304$(call mark_unsupported,CONFIG_DRKAISER CONFIG_NICINTEL CONFIG_NICINTEL_SPI)
305$(call mark_unsupported,CONFIG_NICINTEL_EEPROM CONFIG_OGP_SPI CONFIG_IT8212)
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000306endif
307
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000308###############################################################################
309# Flash chip drivers and bus support infrastructure.
310
Stefan Tauner4404f732013-09-12 08:28:56 +0000311CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000312 sst28sf040.o 82802ab.o \
Paul Kocialkowski80ae14e2018-01-15 01:07:46 +0300313 sst49lfxxxc.o sst_fwhub.o edi.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Nikolai Artemievc9feb1b2021-10-21 01:35:13 +1100314 spi95.o opaque.o sfdp.o en29lv640b.o at45db.o \
315 writeprotect.o writeprotect_ranges.o
Sean Nelson5d134642009-12-24 16:54:21 +0000316
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000317###############################################################################
318# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000319
Thomas Heijligenbbfacff2021-03-31 20:40:01 +0200320LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o programmer_table.o helpers.o ich_descriptors.o fmap.o
Sean Nelson5d134642009-12-24 16:54:21 +0000321
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000322###############################################################################
323# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000324
Stefan Tauner9b32de92014-08-08 23:52:33 +0000325CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000326
Stefan Taunerfa25bc32017-10-04 03:47:26 +0200327# versioninfo.inc stores metadata required to build a packaged flashrom. It is generated by the export rule and
328# imported below. If versioninfo.inc is not found and the variables are not defined by the user, the info will
329# be obtained using util/getrevision.sh, which is the common case during development.
330-include versioninfo.inc
Stefan Tauner5bf6b852017-10-04 03:46:51 +0200331VERSION ?= $(shell ./util/getrevision.sh --revision)
Stefan Tauner96209122017-10-01 16:41:35 +0200332MAN_DATE ?= $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000333
Stefan Tauner76347082016-11-27 17:45:49 +0100334SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000335
Stefan Tauner76347082016-11-27 17:45:49 +0100336# Inform user of the version string
337$(info Replacing all version templates with $(VERSION).)
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000338
Stefan Tauner037cd842013-08-25 00:10:56 +0000339###############################################################################
340# Default settings of CONFIG_* variables.
341
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000342# Always enable internal/onboard support for now.
343CONFIG_INTERNAL ?= yes
344
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000345# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000346CONFIG_SERPROG ?= yes
347
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000348# RayeR SPIPGM hardware support
349CONFIG_RAYER_SPI ?= yes
350
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000351# PonyProg2000 SPI hardware support
352CONFIG_PONY_SPI ?= yes
353
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000354# Always enable 3Com NICs for now.
355CONFIG_NIC3COM ?= yes
356
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000357# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
358CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000359
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000360# Always enable SiI SATA controllers for now.
361CONFIG_SATASII ?= yes
362
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000363# Highpoint (HPT) ATA/RAID controller support.
364# IMPORTANT: This code is not yet working!
365CONFIG_ATAHPT ?= no
366
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000367# VIA VT6421A LPC memory support
368CONFIG_ATAVIA ?= yes
369
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000370# Promise ATA controller support.
371CONFIG_ATAPROMISE ?= no
372
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000373# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000374CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000375
James Lairdc60de0e2013-03-27 13:00:23 +0000376# Always enable Altera USB-Blaster dongles for now.
377CONFIG_USBBLASTER_SPI ?= yes
378
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000379# MSTAR DDC support needs more tests/reviews/cleanups.
380CONFIG_MSTARDDC_SPI ?= no
381
Justin Chevrier66e554b2015-02-08 21:58:10 +0000382# Always enable PICkit2 SPI dongles for now.
383CONFIG_PICKIT2_SPI ?= yes
384
Miklós Márton324929c2019-08-01 19:14:10 +0200385# Always enable STLink V3
386CONFIG_STLINKV3_SPI ?= yes
387
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000388# Always enable dummy tracing for now.
389CONFIG_DUMMY ?= yes
390
391# Always enable Dr. Kaiser for now.
392CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000393
Joerg Fischer5665ef32010-05-21 21:54:07 +0000394# Always enable Realtek NICs for now.
395CONFIG_NICREALTEK ?= yes
396
Andrew Morganc29c2e72010-06-07 22:37:54 +0000397# Disable National Semiconductor NICs until support is complete and tested.
398CONFIG_NICNATSEMI ?= no
399
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000400# Always enable Intel NICs for now.
401CONFIG_NICINTEL ?= yes
402
Idwer Vollering004f4b72010-09-03 18:21:21 +0000403# Always enable SPI on Intel NICs for now.
404CONFIG_NICINTEL_SPI ?= yes
405
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000406# Always enable EEPROM on Intel NICs for now.
407CONFIG_NICINTEL_EEPROM ?= yes
408
Mark Marshall90021f22010-12-03 14:48:11 +0000409# Always enable SPI on OGP cards for now.
410CONFIG_OGP_SPI ?= yes
411
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000412# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000413CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000414
Simon Glassae616512016-01-23 23:27:58 +0000415# Always enable Dediprog SF100 for now.
416CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000417
Daniel Thompson45e91a22018-06-04 13:46:29 +0100418# Always enable Developerbox emergency recovery for now.
419CONFIG_DEVELOPERBOX_SPI ?= yes
420
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000421# Always enable Marvell SATA controllers for now.
422CONFIG_SATAMV ?= yes
423
David Hendricksf9a30552015-05-23 20:30:30 -0700424# Enable Linux spidev and MTD interfaces by default. We disable them on non-Linux targets.
425CONFIG_LINUX_MTD ?= yes
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000426CONFIG_LINUX_SPI ?= yes
427
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000428# Always enable ITE IT8212F PATA controllers for now.
429CONFIG_IT8212 ?= yes
430
Urja Rannikko0870b022016-01-31 22:10:29 +0000431# Winchiphead CH341A
432CONFIG_CH341A_SPI ?= yes
433
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100434# Digilent Development board JTAG
435CONFIG_DIGILENT_SPI ?= yes
436
Jean THOMASe28d8e42022-10-11 17:54:30 +0200437# DirtyJTAG
438CONFIG_DIRTYJTAG_SPI ?= yes
439
Marc Schink3578ec62016-03-17 16:23:03 +0100440# Disable J-Link for now.
441CONFIG_JLINK_SPI ?= no
442
Nico Huber83d52072021-06-27 00:07:13 +0200443# National Instruments USB-845x is Windows only and needs a proprietary library.
444CONFIG_NI845X_SPI ?= no
445
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000446# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000447CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000448
Stefan Taunerf3503372016-02-26 23:51:21 +0000449# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
450ifeq ($(CONFIG_NOTHING), yes)
451 ifeq ($(CONFIG_EVERYTHING), yes)
452 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
453 endif
454 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
455 $(if $(filter yes, $($(var))),\
456 $(eval $(var)=no)))
457endif
458
Patrick Georgiced7ab62015-01-19 19:52:34 +0000459# Enable all features if CONFIG_EVERYTHING=yes is given
460ifeq ($(CONFIG_EVERYTHING), yes)
461$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
462 $(if $(filter no, $($(var))),\
463 $(eval $(var)=yes)))
464endif
465
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000466# Bitbanging SPI infrastructure, default off unless needed.
Nico Huber29c68342021-06-27 14:34:16 +0200467
468ifneq ($(call filter_deps,$(DEPENDS_ON_BITBANG_SPI)), )
Felix Singer4cbc1cb2022-07-22 23:23:28 +0200469override CONFIG_BITBANG_SPI = yes
470else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000471CONFIG_BITBANG_SPI ?= no
472endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000473
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000474###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000475# Handle CONFIG_* variables that depend on others set (and verified) above.
476
477# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
478ifeq ($(TARGET_OS), libpayload)
479ifeq ($(CONFIG_INTERNAL), yes)
480ifeq ($(CONFIG_INTERNAL_DMI), no)
481UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
482else
483override CONFIG_INTERNAL_DMI = yes
484endif
485endif
486endif
487
488# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
489CONFIG_INTERNAL_DMI ?= yes
490
491###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000492# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000493# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000494
Thomas Heijligen84e9c912021-06-01 16:22:14 +0200495ifdef CONFIG_DEFAULT_PROGRAMMER_NAME
496FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=&programmer_$(CONFIG_DEFAULT_PROGRAMMER_NAME)'
497else
498FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=NULL'
499endif
500
Stefan Tauner265fcac2014-06-02 00:12:23 +0000501FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000502
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000503ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000504FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000505PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000506ifeq ($(ARCH), x86)
Edward O'Callaghan2ab6bba2022-06-24 16:48:09 +1000507PROGRAMMER_OBJS += it87spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Nico Huber305f4172013-06-14 11:55:26 +0200508PROGRAMMER_OBJS += ichspi.o dmi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000509ifeq ($(CONFIG_INTERNAL_DMI), yes)
510FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
511endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000512else
513endif
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000514endif
515
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000516ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000517FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000518PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000519NEED_SERIAL += CONFIG_SERPROG
520NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000521endif
522
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000523ifeq ($(CONFIG_RAYER_SPI), yes)
524FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
525PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000526NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000527endif
528
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000529ifeq ($(CONFIG_PONY_SPI), yes)
530FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
531PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000532NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000533endif
534
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000535ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000536FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000537PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000538endif
539
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000540ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000541FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000542PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000543endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000544
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000545ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000546FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000547PROGRAMMER_OBJS += gfxnvidia.o
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000548endif
549
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000550ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000551FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000552PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000553endif
554
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000555ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000556FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000557PROGRAMMER_OBJS += atahpt.o
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000558endif
559
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000560ifeq ($(CONFIG_ATAVIA), yes)
561FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
562PROGRAMMER_OBJS += atavia.o
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000563endif
564
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000565ifeq ($(CONFIG_ATAPROMISE), yes)
566FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
567PROGRAMMER_OBJS += atapromise.o
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000568endif
569
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000570ifeq ($(CONFIG_IT8212), yes)
571FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
572PROGRAMMER_OBJS += it8212.o
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000573endif
574
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000575ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000576# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000577FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000578PROGRAMMER_OBJS += ft2232_spi.o
579endif
580
581ifeq ($(CONFIG_USBBLASTER_SPI), yes)
582# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000583FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000584PROGRAMMER_OBJS += usbblaster_spi.o
585endif
586
Justin Chevrier66e554b2015-02-08 21:58:10 +0000587ifeq ($(CONFIG_PICKIT2_SPI), yes)
588FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
589PROGRAMMER_OBJS += pickit2_spi.o
Justin Chevrier66e554b2015-02-08 21:58:10 +0000590endif
591
Miklós Márton324929c2019-08-01 19:14:10 +0200592ifeq ($(CONFIG_STLINKV3_SPI), yes)
593FEATURE_CFLAGS += -D'CONFIG_STLINKV3_SPI=1'
594PROGRAMMER_OBJS += stlinkv3_spi.o
Miklós Márton324929c2019-08-01 19:14:10 +0200595endif
596
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000597ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000598FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000599PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000600endif
601
602ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000603FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000604PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000605endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000606
Joerg Fischer5665ef32010-05-21 21:54:07 +0000607ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000608FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000609PROGRAMMER_OBJS += nicrealtek.o
Joerg Fischer5665ef32010-05-21 21:54:07 +0000610endif
611
Andrew Morganc29c2e72010-06-07 22:37:54 +0000612ifeq ($(CONFIG_NICNATSEMI), yes)
613FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
614PROGRAMMER_OBJS += nicnatsemi.o
Andrew Morganc29c2e72010-06-07 22:37:54 +0000615endif
616
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000617ifeq ($(CONFIG_NICINTEL), yes)
618FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
619PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000620endif
621
Idwer Vollering004f4b72010-09-03 18:21:21 +0000622ifeq ($(CONFIG_NICINTEL_SPI), yes)
623FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
624PROGRAMMER_OBJS += nicintel_spi.o
Idwer Vollering004f4b72010-09-03 18:21:21 +0000625endif
626
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000627ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
628FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
629PROGRAMMER_OBJS += nicintel_eeprom.o
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000630endif
631
Mark Marshall90021f22010-12-03 14:48:11 +0000632ifeq ($(CONFIG_OGP_SPI), yes)
633FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
634PROGRAMMER_OBJS += ogp_spi.o
Mark Marshall90021f22010-12-03 14:48:11 +0000635endif
636
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000637ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
638FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000639PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000640NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000641endif
642
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000643ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000644FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000645PROGRAMMER_OBJS += dediprog.o
646endif
647
Daniel Thompson45e91a22018-06-04 13:46:29 +0100648ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
649FEATURE_CFLAGS += -D'CONFIG_DEVELOPERBOX_SPI=1'
650PROGRAMMER_OBJS += developerbox_spi.o
Daniel Thompson45e91a22018-06-04 13:46:29 +0100651endif
652
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000653ifeq ($(CONFIG_SATAMV), yes)
654FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
655PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000656endif
657
David Hendricksf9a30552015-05-23 20:30:30 -0700658ifeq ($(CONFIG_LINUX_MTD), yes)
659# This is a totally ugly hack.
660FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_MTD_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_MTD=1'")
661PROGRAMMER_OBJS += linux_mtd.o
662endif
663
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000664ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000665# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000666FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000667PROGRAMMER_OBJS += linux_spi.o
668endif
669
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000670ifeq ($(CONFIG_MSTARDDC_SPI), yes)
671# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000672FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000673NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000674PROGRAMMER_OBJS += mstarddc_spi.o
675endif
676
Urja Rannikko0870b022016-01-31 22:10:29 +0000677ifeq ($(CONFIG_CH341A_SPI), yes)
678FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
679PROGRAMMER_OBJS += ch341a_spi.o
Urja Rannikko0870b022016-01-31 22:10:29 +0000680endif
681
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100682ifeq ($(CONFIG_DIGILENT_SPI), yes)
683FEATURE_CFLAGS += -D'CONFIG_DIGILENT_SPI=1'
684PROGRAMMER_OBJS += digilent_spi.o
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100685endif
686
Jean THOMASe28d8e42022-10-11 17:54:30 +0200687ifeq ($(CONFIG_DIRTYJTAG_SPI), yes)
688FEATURE_CFLAGS += -D'CONFIG_DIRTYJTAG_SPI=1'
689PROGRAMMER_OBJS += dirtyjtag_spi.o
690endif
691
Marc Schink3578ec62016-03-17 16:23:03 +0100692ifeq ($(CONFIG_JLINK_SPI), yes)
Marc Schink3578ec62016-03-17 16:23:03 +0100693FEATURE_CFLAGS += -D'CONFIG_JLINK_SPI=1'
694PROGRAMMER_OBJS += jlink_spi.o
695endif
696
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100697ifeq ($(CONFIG_NI845X_SPI), yes)
698FEATURE_CFLAGS += -D'CONFIG_NI845X_SPI=1'
699
700ifeq ($(CONFIG_NI845X_LIBRARY_PATH),)
701# if the user did not specified the NI-845x headers/lib path
702# do a guess for both 32 and 64 bit Windows versions
703NI845X_LIBS += -L'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100704NI845X_INCLUDES += -I'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Mártonfea5aa12021-07-27 14:29:16 +0200705
706# hack to access env variable containing brackets...
707PROGRAMFILES_X86DIR = $(shell env | sed -n "s/^PROGRAMFILES(X86)=//p")
708
709ifneq ($(PROGRAMFILES_X86DIR),)
710ifneq ($(PROGRAMFILES_X86DIR), ${PROGRAMFILES})
711NI845X_LIBS += -L'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
712NI845X_INCLUDES += -I'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
713endif
714endif
715
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100716else
717NI845X_LIBS += -L'$(CONFIG_NI845X_LIBRARY_PATH)'
718NI845X_INCLUDES += -I'$(CONFIG_NI845X_LIBRARY_PATH)'
719endif
720
721FEATURE_CFLAGS += $(NI845X_INCLUDES)
722LIBS += -lni845x
723PROGRAMMER_OBJS += ni845x_spi.o
724endif
725
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000726ifneq ($(NEED_SERIAL), )
Thomas Heijligen140c1262021-09-27 15:12:26 +0200727LIB_OBJS += serial.o
728ifeq ($(TARGET_OS), Linux)
729LIB_OBJS += custom_baud_linux.o
730else
731LIB_OBJS += custom_baud.o
732endif
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000733endif
734
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000735ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000736ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000737LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000738endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000739endif
740
Nico Huberf55ca202021-06-27 14:36:06 +0200741NEED_LIBPCI := $(call filter_deps,$(DEPENDS_ON_LIBPCI))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000742ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000743CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000744# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
745# libpci may need raw memory, MSR or PCI port I/O on some platforms.
746# Individual drivers might have the same needs as well.
747NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000748FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000749FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000750
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000751PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000752ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000753# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000754PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000755else
756PCILIBS += -lpci
757endif
758endif
759
760ifneq ($(NEED_RAW_ACCESS), )
761# Raw memory, MSR or PCI port I/O access.
762FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
763PROGRAMMER_OBJS += physmap.o hwaccess.o
764
765ifeq ($(TARGET_OS), NetBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200766ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000767PCILIBS += -l$(shell uname -p)
Nico Huber9245b882021-04-18 20:50:32 +0200768endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000769else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000770ifeq ($(TARGET_OS), OpenBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200771ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000772PCILIBS += -l$(shell uname -m)
Nico Huber9245b882021-04-18 20:50:32 +0200773endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000774else
775ifeq ($(TARGET_OS), Darwin)
776# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000777PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000778endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000779endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000780endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000781
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000782endif
783
Nico Huberf55ca202021-06-27 14:36:06 +0200784NEED_LIBUSB1 := $(call filter_deps,$(DEPENDS_ON_LIBUSB1))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000785ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb2016-01-31 22:10:14 +0000786CHECK_LIBUSB1 = yes
Daniel Thompson1d507a02018-07-12 11:02:28 +0100787PROGRAMMER_OBJS += usbdev.o
Stefan Taunere49edbb2016-01-31 22:10:14 +0000788# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
789ifeq ($(TARGET_OS),$(filter $(TARGET_OS),FreeBSD DragonFlyBSD))
790USB1LIBS += -lusb
791else
792ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000793override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb2016-01-31 22:10:14 +0000794USB1LIBS += -lusb-1.0
795else
Stefan Tauner45207062016-02-19 08:17:24 +0000796USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
797override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb2016-01-31 22:10:14 +0000798endif
799endif
800endif
801
Nico Huberf55ca202021-06-27 14:36:06 +0200802NEED_LIBFTDI := $(call filter_deps,$(DEPENDS_ON_LIBFTDI))
Nico Huber09e82e22021-06-27 14:31:37 +0200803ifneq ($(NEED_LIBFTDI), )
804FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
805FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
806FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
807FEATURE_CFLAGS += $(FTDI_INCLUDES)
808FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
809# We can't set NEED_LIBUSB1 here because that would transform libftdi auto-enabling
810# into a hard requirement for libusb, defeating the purpose of auto-enabling.
811endif
812
Nico Huberf55ca202021-06-27 14:36:06 +0200813NEED_LIBJAYLINK := $(call filter_deps,$(DEPENDS_ON_LIBJAYLINK))
Marc Schink3578ec62016-03-17 16:23:03 +0100814ifneq ($(NEED_LIBJAYLINK), )
815CHECK_LIBJAYLINK = yes
816JAYLINKLIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libjaylink)
817override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libjaylink)
818endif
819
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000820ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000821FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000822CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000823endif
824
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000825FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +0000826
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000827# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000828FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000829
Nico Huber8624e8c2012-11-05 21:46:33 +0100830FEATURE_CFLAGS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-D'HAVE_CLOCK_GETTIME=1'")
831FEATURE_LIBS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-lrt")
832
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000833LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000834OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +0000835
Joerg Mayera93d9dc2013-08-29 00:38:19 +0000836all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000837ifeq ($(ARCH), x86)
838 @+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
839endif
840
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000841$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100842 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS) $(JAYLINKLIBS) $(NI845X_LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000843
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000844libflashrom.a: $(LIBFLASHROM_OBJS)
845 $(AR) rcs $@ $^
846 $(RANLIB) $@
847
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +0000848# TAROPTIONS reduces information leakage from the packager's system.
849# If other tar programs support command line arguments for setting uid/gid of
850# stored files, they can be handled here as well.
851TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000852
Paul Fox05dfbe62009-06-16 21:08:06 +0000853%.o: %.c .features
Stefan Tauner76347082016-11-27 17:45:49 +0100854 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +0000855
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +0000856# Make sure to add all names of generated binaries here.
857# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000858# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000859clean:
Stefan Tauner4c723152016-01-14 22:47:55 +0000860 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000861 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000862
Ollie Lho184a4042005-11-26 21:55:36 +0000863distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +0000864 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +0000865
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000866strip: $(PROGRAM)$(EXEC_SUFFIX)
867 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000868
Stefan Tauner56787082011-08-18 02:27:19 +0000869# to define test programs we use verbatim variables, which get exported
870# to environment variables and are referenced with $$<varname> later
871
872define COMPILER_TEST
873int main(int argc, char **argv)
874{
875 (void) argc;
876 (void) argv;
877 return 0;
878}
879endef
880export COMPILER_TEST
881
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000882compiler: featuresavailable
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000883 @printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000884 @echo "$$COMPILER_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000885 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000886 @{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
887 echo "found." || { echo "not found."; \
888 rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000889 @rm -f .test.c .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000890 @printf "Target arch is "
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000891 @# FreeBSD wc will output extraneous whitespace.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000892 @echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900893 ( echo "unknown (\"$(ARCH)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000894 @printf "%s\n" '$(ARCH)'
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000895 @printf "Target OS is "
896 @# FreeBSD wc will output extraneous whitespace.
897 @echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Pyry Kontio89cc73b2020-07-06 12:57:35 +0900898 ( echo "unknown (\"$(TARGET_OS)\"). Aborting."; exit 1)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000899 @printf "%s\n" '$(TARGET_OS)'
Stefan Taunerd6c17f62013-09-12 14:04:31 +0000900ifeq ($(TARGET_OS), libpayload)
901 @$(CC) --version 2>&1 | grep -q coreboot || \
902 ( echo "Warning: It seems you are not using coreboot's reference compiler."; \
903 echo "This might work but usually does not, please beware." )
904endif
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +0000905
Stefan Tauner56787082011-08-18 02:27:19 +0000906define LIBPCI_TEST
907/* Avoid a failing test due to libpci header symbol shadowing breakage */
908#define index shadow_workaround_index
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000909#if !defined PCIUTILS_PCI_H
Stefan Tauner56787082011-08-18 02:27:19 +0000910#include <pci/pci.h>
Stefan Taunerc65b8552013-09-12 15:48:39 +0000911#else
912#include <pciutils/pci.h>
913#endif
Stefan Tauner56787082011-08-18 02:27:19 +0000914struct pci_access *pacc;
915int main(int argc, char **argv)
916{
917 (void) argc;
918 (void) argv;
919 pacc = pci_alloc();
920 return 0;
921}
922endef
923export LIBPCI_TEST
924
Stefan Tauner56734502015-02-08 21:58:04 +0000925define PCI_GET_DEV_TEST
926/* Avoid a failing test due to libpci header symbol shadowing breakage */
927#define index shadow_workaround_index
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000928#if !defined PCIUTILS_PCI_H
Stefan Tauner56734502015-02-08 21:58:04 +0000929#include <pci/pci.h>
930#else
931#include <pciutils/pci.h>
932#endif
933struct pci_access *pacc;
934struct pci_dev *dev = {0};
935int main(int argc, char **argv)
936{
937 (void) argc;
938 (void) argv;
939 pacc = pci_alloc();
940 dev = pci_get_dev(pacc, dev->domain, dev->bus, dev->dev, 1);
941 return 0;
942}
943endef
944export PCI_GET_DEV_TEST
945
Stefan Taunere49edbb2016-01-31 22:10:14 +0000946define LIBUSB1_TEST
947#include <stddef.h>
948#include <libusb.h>
949int main(int argc, char **argv)
950{
951 (void)argc;
952 (void)argv;
953 libusb_init(NULL);
954 return 0;
955}
956endef
957export LIBUSB1_TEST
958
Marc Schink3578ec62016-03-17 16:23:03 +0100959define LIBJAYLINK_TEST
960#include <stddef.h>
961#include <libjaylink/libjaylink.h>
962int main(int argc, char **argv)
963{
964 struct jaylink_context *ctx;
965
966 (void)argc;
967 (void)argv;
968
969 jaylink_init(&ctx);
970 jaylink_exit(ctx);
971
972 return 0;
973}
974endef
975export LIBJAYLINK_TEST
976
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000977hwlibs: compiler
978 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000979ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000980 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000981 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000982 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000983 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
984 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000985 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000986 echo "Please install libpci headers or disable all features"; \
987 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000988 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000989 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
990 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +0000991 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000992 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000993 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +0000994 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000995 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
996 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000997 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000998 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
999 echo "yes." || { echo "no."; \
1000 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001001 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
1002 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001003 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001004 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001005 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
1006 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +00001007 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001008 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001009 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001010endif
Stefan Taunere49edbb2016-01-31 22:10:14 +00001011ifeq ($(CHECK_LIBUSB1), yes)
1012 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
1013 @echo "$$LIBUSB1_TEST" > .test.c
1014 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
1015 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1016 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001017 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001018 echo "Please install libusb-1.0 headers or disable all features"; \
1019 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +00001020 echo "See README for more information."; echo; \
1021 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1022 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
1023 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
1024 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
1025 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001026 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001027 echo "Please install libusb-1.0 or disable all features"; \
1028 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +00001029 echo "See README for more information."; echo; \
1030 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1031 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
1032endif
Marc Schink3578ec62016-03-17 16:23:03 +01001033ifeq ($(CHECK_LIBJAYLINK), yes)
1034 @printf "Checking for libjaylink headers... " | tee -a $(BUILD_DETAILS_FILE)
1035 @echo "$$LIBJAYLINK_TEST" > .test.c
1036 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
1037 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1038 echo "found." || { echo "not found."; echo; \
1039 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
1040 echo "Please install libjaylink headers or disable the feature"; \
1041 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
1042 echo "See README for more information."; echo; \
1043 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1044 @printf "Checking if libjaylink is usable... " | tee -a $(BUILD_DETAILS_FILE)
1045 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS)" >>$(BUILD_DETAILS_FILE)
1046 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS) >&2 && \
1047 echo "yes." || { echo "no."; \
1048 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
1049 echo "Please install libjaylink or disable the feature"; \
1050 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
1051 echo "See README for more information."; echo; \
1052 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1053 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
1054endif
Stefan Reinauer53e96252005-12-01 16:19:24 +00001055
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001056.features: features
1057
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001058# If a user does not explicitly request a non-working feature, we should
1059# silently disable it. However, if a non-working (does not compile) feature
1060# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001061# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001062featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001063ifeq ($(PROGRAMMER_OBJS),)
1064 @echo "You have to enable at least one programmer driver!"
1065 @false
1066endif
1067ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001068 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
1069 @false
1070endif
1071
Stefan Tauner56787082011-08-18 02:27:19 +00001072define FTDI_TEST
Stefan Tauner5c316f92015-02-08 21:57:52 +00001073#include <stdlib.h>
Stefan Tauner56787082011-08-18 02:27:19 +00001074#include <ftdi.h>
1075struct ftdi_context *ftdic = NULL;
1076int main(int argc, char **argv)
1077{
1078 (void) argc;
1079 (void) argv;
1080 return ftdi_init(ftdic);
1081}
1082endef
1083export FTDI_TEST
1084
Ilya A. Volynets-Evenbakh2c714ab2012-09-26 00:47:09 +00001085define FTDI_232H_TEST
1086#include <ftdi.h>
1087enum ftdi_chip_type type = TYPE_232H;
1088endef
1089export FTDI_232H_TEST
1090
Stefan Tauner56787082011-08-18 02:27:19 +00001091define UTSNAME_TEST
1092#include <sys/utsname.h>
1093struct utsname osinfo;
1094int main(int argc, char **argv)
1095{
1096 (void) argc;
1097 (void) argv;
1098 uname (&osinfo);
1099 return 0;
1100}
1101endef
1102export UTSNAME_TEST
1103
David Hendricksf9a30552015-05-23 20:30:30 -07001104define LINUX_MTD_TEST
1105#include <mtd/mtd-user.h>
1106
1107int main(int argc, char **argv)
1108{
1109 (void) argc;
1110 (void) argv;
1111 return 0;
1112}
1113endef
1114export LINUX_MTD_TEST
1115
Stefan Tauner8868db32012-03-13 00:18:19 +00001116define LINUX_SPI_TEST
1117#include <linux/types.h>
1118#include <linux/spi/spidev.h>
1119
1120int main(int argc, char **argv)
1121{
1122 (void) argc;
1123 (void) argv;
1124 return 0;
1125}
1126endef
1127export LINUX_SPI_TEST
1128
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001129define LINUX_I2C_TEST
1130#include <linux/i2c-dev.h>
1131#include <linux/i2c.h>
1132
1133int main(int argc, char **argv)
1134{
1135 (void) argc;
1136 (void) argv;
1137 return 0;
1138}
1139endef
1140export LINUX_I2C_TEST
1141
Nico Huber8624e8c2012-11-05 21:46:33 +01001142define CLOCK_GETTIME_TEST
1143#include <time.h>
1144
1145int main(int argc, char **argv)
1146{
1147 struct timespec res;
1148 clock_gettime(CLOCK_REALTIME, &res);
1149 return 0;
1150}
1151endef
1152export CLOCK_GETTIME_TEST
1153
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001154define NI845X_TEST
1155#include <ni845x.h>
1156
1157int main(int argc, char **argv)
1158{
1159 (void) argc;
1160 (void) argv;
1161 char I2C_Device[256];
1162 NiHandle Dev_Handle;
1163 uInt32 NumberFound = 0;
1164 ni845xFindDevice(I2C_Device, &Dev_Handle, &NumberFound);
1165 ni845xCloseFindDeviceHandle(Dev_Handle);
1166 return 0;
1167}
1168endef
1169export NI845X_TEST
1170
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001171features: compiler
1172 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001173ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001174 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001175 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001176 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001177 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1178 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
1179 printf "Checking for FT232H support in libftdi... " ; \
1180 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001181 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001182 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1183 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
1184 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
1185 ) || \
1186 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
1187 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +00001188endif
David Hendricksf9a30552015-05-23 20:30:30 -07001189ifeq ($(CONFIG_LINUX_MTD), yes)
1190 @printf "Checking if Linux MTD headers are present... " | tee -a $(BUILD_DETAILS_FILE)
1191 @echo "$$LINUX_MTD_TEST" > .featuretest.c
1192 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1193 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1194 ( echo "yes."; echo "LINUX_MTD_SUPPORT := yes" >> .features.tmp ) || \
1195 ( echo "no."; echo "LINUX_MTD_SUPPORT := no" >> .features.tmp ) } \
1196 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1197endif
Stefan Tauner8868db32012-03-13 00:18:19 +00001198ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001199 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001200 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001201 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001202 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +00001203 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001204 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
1205 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001206endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001207ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001208 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001209 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001210 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001211 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001212 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001213 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
1214 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001215endif
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001216ifeq ($(CONFIG_NI845X_SPI), yes)
1217 @printf "Checking for NI USB-845x installation... " | tee -a $(BUILD_DETAILS_FILE)
1218 @echo "$$NI845X_TEST" > .featuretest.c
1219 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
1220
1221 @ { { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS) >&2 && \
1222 ( echo "yes."; echo "NI845X_SUPPORT := yes" >> .features.tmp ) || \
1223 { echo -e "\nUnable to find NI-845x headers or libraries."; \
1224 echo "Please pass the NI-845x library path to the make with the CONFIG_NI845X_LIBRARY_PATH parameter,"; \
1225 echo "or disable the NI-845x support by specifying make CONFIG_NI845X_SPI=no"; \
1226 echo "For the NI-845x 17.0 the library path is:"; \
1227 echo " On 32 bit systems: C:\Program Files)\National Instruments\NI-845x\MS Visual C"; \
1228 echo " On 64 bit systems: C:\Program Files (x86)\National Instruments\NI-845x\MS Visual C"; \
1229 exit 1; }; } \
1230 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1231endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001232 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001233 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001234 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001235 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001236 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001237 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Nico Huber8624e8c2012-11-05 21:46:33 +01001238 @printf "Checking for clock_gettime support... " | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001239ifeq ($(DISABLE_CLOCK_GETTIME), yes)
1240 @ { ( echo "disabled."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1241 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1242else
Nico Huber8624e8c2012-11-05 21:46:33 +01001243 @echo "$$CLOCK_GETTIME_TEST" >.featuretest.c
1244 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1245 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1246 ( echo "found."; echo "CLOCK_GETTIME := yes" >>.features.tmp ) || \
1247 ( echo "not found."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1248 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001249endif
Stefan Tauner56787082011-08-18 02:27:19 +00001250 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1251 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001252
Stefan Tauner4c723152016-01-14 22:47:55 +00001253$(PROGRAM).8.html: $(PROGRAM).8
1254 @groff -mandoc -Thtml $< >$@
1255
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001256$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001257 @# Add the man page change date and version to the man page
Nico Huberac90af62022-12-18 00:22:47 +00001258 @sed -e 's#.TH FLASHROM 8 .*#.TH FLASHROM 8 "$(MAN_DATE)" "flashrom-stable-$(VERSION)" "$(MAN_DATE)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001259
1260install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001261 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001262 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001263 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001264 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001265
Nico Huber454f6132012-12-10 13:34:10 +00001266libinstall: libflashrom.a libflashrom.h
1267 mkdir -p $(DESTDIR)$(PREFIX)/lib
1268 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1269 mkdir -p $(DESTDIR)$(PREFIX)/include
1270 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1271
Nico Huber5f245a22023-01-10 17:14:47 +01001272versioninfo:
1273# Generate versioninfo.inc containing metadata that would not be available in exported sources otherwise.
1274 @[ "$(RELEASE)" ] || { echo 'Error: Must provide `RELEASE=...`'; exit 1; }
1275 @echo "VERSION = $(RELEASE)" > $@.inc
1276 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> $@.inc
1277
1278# No spaces in release names unless set explicitly
1279RELEASENAME ?= $(shell echo "$(VERSION)" | sed -e 's/ /_/')
1280
1281_export: EXPORT_VERSIONINFO := $(EXPORTDIR)/flashrom-$(RELEASENAME)/versioninfo.inc
Stefan Tauner76347082016-11-27 17:45:49 +01001282_export: $(PROGRAM).8
1283 @rm -rf "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
1284 @mkdir -p "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
1285 @git archive HEAD | tar -x -C "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
Nico Huber5f245a22023-01-10 17:14:47 +01001286# Generate fresh versioninfo.inc and compare
1287 @echo "VERSION = $(shell ./util/getrevision.sh --revision)" > "$(EXPORT_VERSIONINFO)"
1288 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> \
1289 "$(EXPORT_VERSIONINFO)"
1290 @if [ -f versioninfo.inc ]; then \
1291 cmp -s versioninfo.inc "$(EXPORT_VERSIONINFO)" || \
1292 { echo Error: Version info changed:; \
1293 cat "$(EXPORT_VERSIONINFO)"; \
1294 echo Update versioninfo.inc and tag accordingly.; \
1295 exit 1; \
1296 }; \
1297 fi
Stefan Taunere4136852017-10-01 15:57:25 +02001298# Restore modification date of all tracked files not marked 'export-ignore' in .gitattributes.
1299# sed is required to filter out file names having the attribute set.
1300# The sed program saves the file name in the hold buffer and then checks if the respective value is 'set'.
1301# If so it ignores the rest of the program, which otherwise restores the file name and prints it.
Stefan Tauner76347082016-11-27 17:45:49 +01001302 @git ls-tree -r -z -t --full-name --name-only HEAD | \
1303 git check-attr -z --stdin export-ignore | \
Stefan Taunere4136852017-10-01 15:57:25 +02001304 sed -zne 'x;n;n;{/^set$$/b;};x;p;' | \
Stefan Tauner76347082016-11-27 17:45:49 +01001305 xargs -0 sh -c 'for f; do \
1306 touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
1307 "$(EXPORTDIR)/flashrom-$(RELEASENAME)/$$f"; \
Stefan Taunere4136852017-10-01 15:57:25 +02001308 done' dummy_arg0
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001309
Stefan Tauner76347082016-11-27 17:45:49 +01001310export: _export
1311 @echo "Exported $(EXPORTDIR)/flashrom-$(RELEASENAME)/"
1312
1313tarball: _export
David Hendrickse1a960e2017-10-19 14:54:44 -07001314 @tar -cj --format=ustar -f "$(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2" -C $(EXPORTDIR)/ \
Stefan Tauner60f7a222017-10-01 15:45:06 +02001315 $(TAROPTIONS) "flashrom-$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001316# Delete the exported directory again because it is most likely what's expected by the user.
1317 @rm -rf "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
David Hendrickse1a960e2017-10-19 14:54:44 -07001318 @echo Created "$(EXPORTDIR)/flashrom-$(RELEASENAME).tar.bz2"
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001319
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001320libpayload: clean
1321 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001322
Felix Singer9441c6e2022-10-21 12:47:11 +02001323gitconfig:
1324 ./util/getrevision.sh -c 2>/dev/null && ./util/git-hooks/install.sh
1325
Nico Huber5f245a22023-01-10 17:14:47 +01001326.PHONY: all install clean distclean compiler hwlibs features versioninfo _export export tarball featuresavailable libpayload gitconfig
Ollie Lho184a4042005-11-26 21:55:36 +00001327
Stefan Tauner23e10b82016-01-23 16:16:49 +00001328# Disable implicit suffixes and built-in rules (for performance and profit)
1329.SUFFIXES:
1330
Stefan Reinauere2f01582010-06-07 11:08:07 +00001331-include $(OBJS:.o=.d)